#! usr/bin/perl -w

use strict;
use warnings;

# mode == 1 : phpBB forum mode
# mode == 2 : html mode
my $mode = 2; #FIXME

die unless @ARGV==2;

#######################

#input
my $fileA = shift @ARGV;
my $fileB = shift @ARGV;

#######################

my $br = "";
$br = "<br>" if $mode ==2;

my %varsA;
my %lineA;
my @varsA;

my %varsB;
my %lineB;
my @varsB;

my $versionA = $fileA;
my $versionB = $fileB;

$versionA =~ s/.*?([.\w]*)_reformed.cfg/$1/;
$versionB =~ s/.*?([.\w]*)_reformed.cfg/$1/;

&getData(\$fileA, \%lineA, \%varsA, \@varsA);
&getData(\$fileB, \%lineB, \%varsB, \@varsB);

#######################

#output
my $output = "Thyme_diff_$versionA-$versionB.txt";
$output =~ s/\.txt$/.html/ if $mode == 2;

open FO, ">$output";
my $oldfh = select(FO);

#######################
print &subject("$versionA -> $versionB");

&redColor(\$versionA);
&redColor(\$versionB);

#######################
print &subtitle("Removed elements");

foreach my $var (@varsA)
{
    unless (defined $varsB{$var}) {
        print "$versionA (line=$lineA{$var}): ";
        print $var ." : ". $varsA{$var} . "$br\n";
    };
}

#######################
print &subtitle("Added elements");

foreach my $var (@varsB)
{
    unless (defined $varsA{$var}) {
        print "$versionB (line=$lineB{$var}): ";
        print $var ." : ". $varsB{$var} . "$br\n";
    };
}


#######################
print &subtitle("Changed elements");

foreach my $var (@varsA)
{
    if (defined $varsA{$var}) {
        next if (!(defined $varsB{$var}) || $varsA{$var} eq $varsB{$var});

        print <<EOD
$var$br
$versionA (line=$lineA{$var}): $varsA{$var}$br
$versionB (line=$lineB{$var}): $varsB{$var}$br
$br
EOD
;
    };
}

#######################
close FO;
select ($oldfh);

exit;

#######################
sub getData($$$)
{
    my ($file, $lineHash, $valueHash, $varsArray) = @_;
    my $line;
    my $var;
    my $value;

    open F, "<$$file";

    while (<F>){
        if (/^__(\d+)__\[(".*") *, *(".*") *\]/) { # ["default", "Default"],
            $line = $1;
            $var = $2;
            $value = $3;
        } elsif (/^__(\d+)__([^=]*?) *= *(.*)/) {
            $line = $1;
            $var = $2;
            $value = $3;
        } else {
            next;
        }

        if($mode == 1) {
            $var = "[color=blue]${var}[/color]";
        } elsif($mode == 2) {
            $var = "<font color=blue>${var}</font>";
        }

        $$lineHash{$var} = $line;
        push @$varsArray, $var;
        $$valueHash{$var} = $value;
    }

    close F;
}

sub subject($)
{
    my $title = shift;

    if($mode == 1) {
        $title = "[size=150]${title}[/size]";
    } elsif($mode == 2) {
        $title = "<font size=+3>${title}</font>";
    }

    return "$title";
}

sub subtitle($)
{
    my $title = shift;
    $title = "== $title ==";

    if($mode == 1) {
        $title = "[b][color=orange][size=120]${title}[/size][/color][/b]";
    } elsif($mode == 2) {
        $title = "<font size=+2 color=orange>${title}</font>";
    }
    return "$br\n$br\n$title$br\n";
}

sub redColor($$)
{
    my $string = shift;

    if ($mode == 1) {
        $$string = "[color=red]$${string}[/color]";
    } elsif ($mode == 2) {
        $$string = "<font color=red>$${string}</font>";
    }
}

