#! usr/bin/perl -w

use strict;
use warnings;

die unless @ARGV == 2;

my $input = shift @ARGV;
my $output = shift @ARGV;

open F, "<$input";

my $lineNum = 1;
my $data ="";

while(<F>){
    $data .= "__${lineNum}__ $_";
    $lineNum++;
}
close F;

my $newline = "(\\n__\\d+__)";

$data =~ s/\t/    /g; # タブを空白で置換
$data =~ s/\/\*[\d\D]*?\*\///g; # /*～*/ の部分を削除
$data =~ s/\/\/.*//g; # //～ の部分を削除
$data =~ s/ *$newline/$1/g; # 行末の空白を削除
#$data =~ s/"[ \t]*\+[ \t]*\n[ \t]*"/"+"/g; # 文字列の一行化 (" " + " ")
#$data =~ s/\"[ \t]*\+[ \t]*\r[ \t]*\"//g; # 文字列の一行化 ("A" + "B" → "AB")
$data =~ s/\"[ \t]*\+[ \t]*$newline[ \t]*\"//g; # 文字列の一行化 ("A" + "B" → "AB")
$data =~ s/=$newline/=/g; # =の後の改行を削除

$data =~ s/$newline+/$1/g; # 空行の削除
$data =~ s/$newline */$1/g; # 先頭の空白の削除
$data =~ s/^$newline//g; # 空行の削除

open F, ">$output";
print F $data;
close F;

