#!/usr/bin/perl -w

#Copyright (C) 2011 Tatt61880 (tatt61880@gmail.com, @tatt61880)
#Last Change: 2011/02/05 11:41:23.

use strict;
use warnings;
use Archive::Zip;

#timestamp
my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
$year += 1900;
$mon += 1;
#my $time_stamp = sprintf "%4d%02d%02d%02d%02d%02d", $year, $mon, $mday, $hour, $min, $sec;
my $time_stamp = sprintf "%4d_%02d%02d_%02d%02d", $year, $mon, $mday, $hour, $min;

my $PROJECT_NAME = 'translation_diff';

open F, "<README.txt";
my $version = "0";
while(<F>)
{
    if(m/Translation diff (.*)/)
    {
        $version = $1;
    }
}
close F;

# output file
my $zip_file = "${PROJECT_NAME}_${version}_$time_stamp.zip";

# files
my $zip = Archive::Zip->new();

$zip->addFile("./MAKEFILE");
$zip->addTree("source_codes", "source_codes");
$zip->addTree("files", "files");
$zip->addTree("reformed_files", "reformed_files");
$zip->addFile("./README.txt");

$zip->addFile("./$0");


$zip->writeToFileNamed($zip_file);
print "Output file: $zip_file\n";

exit (0);

